<script lang="ts" setup>
import { nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import type { Product } from '@/types/Product'
import { useProductStore } from '@/stores/product'
import { useTypeStore } from '@/stores/type'
const productStore = useProductStore()
const headers = [
  {
    title: 'Id',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Photo',
    key: 'image'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Price',
    key: 'price'
  },
  {
    title: 'Type',
    key: 'type',
    value: (item: any | Product) => item.type.name
  },
  { title: 'Actions', key: 'actions', sortable: false }
]
const typeStore = useTypeStore()
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const types = ref()

function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    productStore.clearForm()
  })
}
async function deleteItemConfirm() {
  // Delete item from list
  await productStore.deleteProduct()
  closeDelete()
}
async function editItem(item: Product) {
  if (!item.id) return
  await productStore.getProduct(item.id)
  dialog.value = true
}
async function deleteItem(item: Product) {
  if (!item.id) return
  await productStore.getProduct(item.id)
  dialogDelete.value = true
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    productStore.clearForm()
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await productStore.saveProduct()
  closeDialog()
}

onMounted(async () => {
  await productStore.getProducts()
  await typeStore.getTypes()
})

const productDetailsDialog = ref(false)
const selectedProduct = ref<Product | null>(null)

function showIngredientDetails(item: Product) {
  productStore
    .getProduct(item.id) // เรียกใช้เมธอดใน Store เพื่อดึงข้อมูลสินค้า
    .then(() => {
      selectedProduct.value = productStore.editedProduct // กำหนดข้อมูลสินค้าที่ได้จาก Store ให้กับตัวแปร selectedProduct
      productDetailsDialog.value = true // เปิด dialog แสดงรายละเอียดสินค้า
    })
    .catch((error) => {
      console.error('Error fetching product details:', error)
    })
}

function closeProductDetailsDialog() {
  productDetailsDialog.value = false // ปิด dialog แสดงรายละเอียดสินค้า
}
</script>
<template>
  <div>
    <v-data-table class="container" :headers="headers" :items="productStore.products">
      <template v-slot:top>
        <v-toolbar flat>
          <v-toolbar-title>Products</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <!-- Put Edited Dialog -->

          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn color="primary" v-bind="props"> New Product </v-btn>
            </template>
            <v-card class="card">
              <v-card-title class="card-title">
                <span class="text-h5">Product Profile</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="productStore.editedProduct.name"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Name"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model.number="productStore.editedProduct.price"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Price"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="6">
                        <v-combobox
                          v-model="productStore.editedProduct.type"
                          :items="typeStore.types"
                          item-title="name"
                          item-value="id"
                          label="Select types"
                          :return-object="true"
                        ></v-combobox>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-file-input
                          v-model="productStore.editedProduct.files"
                          :rules="[
                            (value) => {
                              return (
                                !value ||
                                !value.length ||
                                value[0].size < 2000000 ||
                                'Image size should be less than 2 MB!'
                              )
                            }
                          ]"
                          accept="image/png, image/jpeg"
                          placeholder="Pick an image"
                          prepend-icon="mdi-camera"
                          label="Avatar"
                        ></v-file-input>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-img
                          class="v-img"
                          :src="
                            'http://localhost:3000/images/products/' +
                            productStore.editedProduct.image
                          "
                          width="200"
                          @click="showProductDetails(productStore.editedProduct)"
                        ></v-img>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn class="btn" @click="closeDialog()"> Close </v-btn>
                <v-btn class="btn" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <!-- Delete Dialog-->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card class="card">
              <v-card-title class="card-title"
                >Are you sure you want to delete this item?</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn class="btn" @click="closeDelete">Cancel</v-btn>
                <v-btn class="btn" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <!-- Product Details Dialog -->
          <v-dialog v-model="productDetailsDialog" max-width="800px">
            <v-card class="card">
              <v-card-title class="card-title">Product Details</v-card-title>
              <v-card-text v-if="selectedProduct">
                <v-container>
                  <v-row>
                    <v-col cols="12" sm="6">
                      <strong>Name:</strong> {{ selectedProduct.name }}
                    </v-col>
                    <v-col cols="12" sm="6">
                      <strong>Price:</strong> {{ selectedProduct.price }}
                    </v-col>
                    <!-- เพิ่มรายละเอียดอื่น ๆ ตามต้องการ -->
                  </v-row>
                </v-container>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn class="btn" @click="closeProductDetailsDialog">Close</v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:item.actions="slotProps">
        <v-icon class="icon" size="small" @click="editItem(slotProps.item)">mdi-pencil</v-icon>
        <v-icon class="icon" size="small" @click="deleteItem(slotProps.item)">mdi-delete</v-icon>
      </template>
      <template v-slot:item.image="{ item }">
        <v-img
          class="icon"
          :src="'http://localhost:3000/images/products/' + item.image"
          width="100"
          @click="showIngredientDetails(item)"
        ></v-img>
      </template>
      <template v-slot:no-data>
        <v-btn class="btn" color="primary" @click="productStore.getProducts">Reset</v-btn>
      </template>
    </v-data-table>
  </div>
</template>
<style scoped>
.container {
  background-color: rgba(202, 174, 123, 0.582);
  padding: 20px;
}

.card {
  background-color: #ffffff;
  border-radius: 8px;
  box-shadow: 0 4px 6px rgba(0, 0, 0, 0.1);
  padding: 20px;
}

.card-title {
  color: #000000;
  font-size: 1.5em;
  margin-bottom: 20px;
}

.btn {
  background-color: #ffffff;
  color: #ffffff;
  border-radius: 4px;
  padding: 10px 20px;
  text-transform: uppercase;
  font-weight: bold;
  transition: background-color 0.3s ease;
}

.btn:hover {
  background-color: #dcdde0;
}

.icon {
  color: #000000;
}

.v-data-table {
  font-size: 14px;
}

.v-col {
  margin-bottom: 15px;
}

.small-margin {
  color: #000000;
  margin-right: 10px;
}

.v-btn.primary {
  background-color: #795548;
  color: #ffffff;
}

.v-btn.primary:hover {
  background-color: #a1887f;
}

.v-data-table-header th {
  background-color: #5d4037;
  color: #ffffff;
}

.v-data-table tbody tr:nth-child(even) {
  background-color: #fafafa;
}
</style>
